Subject: RE: [PATCH v4 net-next 3/3] net: ena: Add PHC documentation

From: "Arinzon, David" <[email-masked]>
Date: Tue, 19 Nov 2024 08:45:52 +0000

> On Sat, Nov 16, 2024 at 05:53:26PM -0800, Richard Cochran wrote:
> > On Thu, Nov 14, 2024 at 11:59:30AM +0200, David Arinzon wrote:
> >
> > > +**phc_skp**         Number of skipped get time attempts (during block
> period).
> > > +**phc_err**         Number of failed get time attempts (entering into
> block state).
> >
> > Just curious...  I understand that the HW can't support a very high
> > rate of gettime calls and that the driver will throttle them.
> >
> > But why did you feel the need to document the throttling behavior in
> > such a overt way?  Are there user space programs out there calling
> > gettime excessively?
> 
> Answering my own question (maybe)
> 
> I see that your PHC only supports gettime(), and so I guess you must have
> some atypical system setup in mind.
> 
> I didn't see any comments in the cover letter or in the patch about why the
> PHC isn't adjustable or how offering gettime() only is useful?
> 
> Thanks,
> Richard

Hi Richard
	
Thank you for the queries.

Our device limits the number of requests per client (VM) through throttling.
To avoid reaching our device throttling limit and ensure a fail-fast mechanism,
the driver preemptively applies throttling.
In addition, AWS cannot be adjusted or controlled by the OS/User to correct any time deviations,
instead, AWS manages the synchronization and accuracy of the clock internally and provides a
pre-disciplined clock that already adheres to Coordinated Universal Time (UTC) standards.
An upcoming patch, which is a continuation of https://lore.kernel.org/netdev/[email-masked]/T/#m58cf9b05b34046b3952ae8bf4cc7d7f2c8b011d7,
will introduce the error bound in ENA PHC, providing internal AWS accuracy error measurements (in nanoseconds).

Thanks,
David